#include <tap.h>
#include "libFireBird.h"

TAP_ID( 0x81a9fe99 );
#define TAPNAME "HiddenKeys"
TAP_PROGRAM_NAME(TAPNAME);
TAP_AUTHOR_NAME("R2-D2");
TAP_DESCRIPTION("Enables hidden keys on the TF5800");
TAP_ETCINFO(__DATE__);

// TSRCommander stuff:
#include "TSRCommander.h"

bool TSRCommanderExitTAP()
{
  return TRUE;
}

void TSRCommanderConfigDialog()
{
}


// *** START OF CRITICAL SECTION - DO NOT CHANGE ***
// Put this *after* any other EventHandler manipulation (like TSRCommander) and before the real EventHandler
dword RealKey_TAP_EventHandler( word event, dword param1, dword param2 );
dword TAP_EventHandler( word event, dword param1, dword param2 )
{
  dword res;
  res = RealKey_TAP_EventHandler(event, param1, param2);
  if(res != param1 && (res & 0xFF000) == 0xFF000) // Altered, and to a hidden value?
    __asm__ __volatile__ ("or $22,$0,%0\n" : : "r"(res));
  return res;
}
#undef TAP_EventHandler
#define TAP_EventHandler RealKey_TAP_EventHandler
// *** END OF CRITICAL ***



#define DELAYTICK (100)

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
  static dword last = 0;
  if(event == EVT_IDLE)
  {
    if(last)
    {
      dword tick = TAP_GetTick();
      if(tick - last > DELAYTICK)
        last = 0;
    }
  }
  else if(event == EVT_KEY && ((param1>>16) == 0x1))
  {
    if(!last)
    {
      if(param1 == RKEY_0)
      {
        last = TAP_GetTick();
        param1 = 0;
      }
    }
    else
    {
      last = 0;
      switch(param1 & 0xFFFF)
      {
      case 0:
        /* NOP */      TAP_Print("0\n");
        break;
      case 1:
        param1 = 0xff007; TAP_Print("Prev\n");
        break;
      case 2:
        param1 = 0xff001; TAP_Print("AVMenu\n");
        break;
      case 3:
        param1 = 0xff008; TAP_Print("Next\n");
        break;
      case 4:
        param1 = 0xff002; TAP_Print("Sleep\n");
        break;
      case 5:
        param1 = 0xff009; TAP_Print("Set bookmark\n");
        break;
      case 6:
        param1 = 0xff00a; TAP_Print("Goto bookmark\n");
        break;
      case 7:
        param1 = 0xff005; TAP_Print("Subt\n");
        break;
/*
      case 8:
        param1 = 0xff006; TAP_Print("Ttx\n");
        break;
*/
      case 9:
        param1 = 0xff003; TAP_Print("AudioTrk\n");
        break;
      }
    }
  }
  return param1;
}

int TAP_Main(void)
{
  // Signature of the TF5800 key manipulation stuff -- ensures that $s6 is the correct register
  dword p = FindInstructionSequence(
    "02a0b025 03c0c825 0c051334 02a02025 3c188019 240fffff 3c158019 af220000 af0f3244 0000a025 26b53044 8eb20010 52400019 26b50020 3c198019 af343244 8e50001c 8fd10000 8eb20004 03c07825 00000000 00000000 03801025 00000000 00000000 0240e025 24040100 02202825 0200f809 00003025 afc20000",
    "ffffffff ffffffff fc000000 ffffffff ffff0000 ffffffff ffff0000 ffffffff ffff0000 ffffffff ffff0000 ffffffff ffffffff ffffffff ffff0000 ffff0000 ffffffff ffffffff ffffffff ffffffff ffffffff 00000000 ffffffff 00000000 00000000 ffffffff ffffffff ffffffff ffffffff 00000000 ffffffff",
    0x80100000, 0x80180000, 0, FALSE);
  if(p)
  {
    // Signature found: must be TF5800-style with hidden keys
    TAP_Print("Starting\n");
    return 1;
  }
  else // Not found: remote probably has the real keys
    TAP_Print("Not found\n");
  return 0;
}
